diff --git a/forward.c b/forward.c
index b1620ea1452..f751549fa1b 100644
--- a/forward.c
+++ b/forward.c
@@ -543,7 +543,7 @@ int forward_reply(struct sip_msg* msg)
 	if (msg->flags & tcp_no_new_conn_rplflag)
 		tcp_no_new_conn = 1;
 
-	if (msg_send(send_sock, proto, to, (int)id, new_buf, new_len, msg)<0) {
+	if (msg_send(send_sock, proto, to, id, new_buf, new_len, msg)<0) {
 		tcp_no_new_conn = 0;
 		update_stat( drp_rpls, 1);
 		goto error0;
diff --git a/forward.h b/forward.h
index ae18d82ae87..37005982989 100644
--- a/forward.h
+++ b/forward.h
@@ -82,7 +82,7 @@ int forward_reply( struct sip_msg* msg);
  * \return 0 if ok, -1 on error
  */
 static inline int msg_send( struct socket_info* send_sock, int proto,
-							union sockaddr_union* to, int id,
+							union sockaddr_union* to, unsigned int id,
 							char* buf, int len, struct sip_msg* msg)
 {
 	str out_buff;
diff --git a/ip_addr.h b/ip_addr.h
index 762aee7e160..bc81429eb93 100644
--- a/ip_addr.h
+++ b/ip_addr.h
@@ -96,8 +96,8 @@ struct receive_info {
 	unsigned short src_port; /*!< host byte order */
 	unsigned short dst_port; /*!< host byte order */
 	int proto;
-	int proto_reserved1; /*!< tcp stores the connection id here */
-	int proto_reserved2;
+	unsigned int proto_reserved1; /*!< tcp stores the connection id here */
+	unsigned int proto_reserved2;
 	union sockaddr_union src_su; /*!< useful for replies*/
 	struct socket_info* bind_address; /*!< sock_info structure on which the msg was received*/
 	/* no need for dst_su yet */
@@ -106,7 +106,7 @@ struct receive_info {
 
 struct dest_info {
 	int proto;
-	int proto_reserved1; /*!< tcp stores the connection id here */
+	unsigned int proto_reserved1; /*!< tcp stores the connection id here */
 	union sockaddr_union to;
 	struct socket_info* send_sock;
 };
diff --git a/modules/proto_bin/proto_bin.c b/modules/proto_bin/proto_bin.c
index be620511fb5..d987cfe88ea 100644
--- a/modules/proto_bin/proto_bin.c
+++ b/modules/proto_bin/proto_bin.c
@@ -46,7 +46,8 @@ static int mod_init(void);
 static int proto_bin_init(struct proto_info *pi);
 static int proto_bin_init_listener(struct socket_info *si);
 static int proto_bin_send(struct socket_info* send_sock,
-		char* buf, unsigned int len, union sockaddr_union* to, int id);
+		char* buf, unsigned int len, union sockaddr_union* to,
+		unsigned int id);
 static int bin_read_req(struct tcp_connection* con, int* bytes_read);
 static int bin_write_async_req(struct tcp_connection* con,int fd);
 static int bin_conn_init(struct tcp_connection* c);
@@ -511,7 +512,8 @@ inline static int _bin_write_on_socket(struct tcp_connection *c, int fd,
 }
 
 static int proto_bin_send(struct socket_info* send_sock,
-		char* buf, unsigned int len, union sockaddr_union* to, int id)
+		char* buf, unsigned int len, union sockaddr_union* to,
+		unsigned int id)
 {
 	struct tcp_connection *c;
 	struct ip_addr ip;
diff --git a/modules/proto_hep/proto_hep.c b/modules/proto_hep/proto_hep.c
index b36626cbd5f..a944524d3c6 100644
--- a/modules/proto_hep/proto_hep.c
+++ b/modules/proto_hep/proto_hep.c
@@ -59,9 +59,11 @@ static int hep_write_async_req(struct tcp_connection* con,int fd);
 static int hep_tcp_read_req(struct tcp_connection* con, int* bytes_read);
 static int hep_udp_read_req(struct socket_info *si, int* bytes_read);
 static int hep_udp_send (struct socket_info* send_sock,
-		char *buf, unsigned int len, union sockaddr_union *to, int id);
+		char *buf, unsigned int len, union sockaddr_union *to,
+		unsigned int id);
 static int hep_tcp_send (struct socket_info* send_sock,
-		char *buf, unsigned int len, union sockaddr_union *to, int id);
+		char *buf, unsigned int len, union sockaddr_union *to,
+		unsigned int id);
 static void update_recv_info(struct receive_info *ri, struct hep_desc *h);
 
 void free_hep_context(void* ptr);
@@ -671,7 +673,8 @@ inline static int _hep_write_on_socket(struct tcp_connection *c, int fd,
 }
 
 static int hep_udp_send (struct socket_info* send_sock,
-		char *buf, unsigned int len, union sockaddr_union *to, int id)
+		char *buf, unsigned int len, union sockaddr_union *to,
+		unsigned int id)
 {
 	int n, tolen;
 
@@ -693,7 +696,8 @@ static int hep_udp_send (struct socket_info* send_sock,
 }
 
 static int hep_tcp_send (struct socket_info* send_sock,
-		char *buf, unsigned int len, union sockaddr_union *to, int id)
+		char *buf, unsigned int len, union sockaddr_union *to,
+		unsigned int id)
 {
 	struct tcp_connection *c;
 	int port=0;
diff --git a/modules/proto_sctp/sctp_server.c b/modules/proto_sctp/sctp_server.c
index f1a302dec8a..e48f4d56be7 100644
--- a/modules/proto_sctp/sctp_server.c
+++ b/modules/proto_sctp/sctp_server.c
@@ -190,7 +190,7 @@ int proto_sctp_read(struct socket_info *si, int* bytes_read)
 
 /*! \brief which socket to use? main socket or new one? */
 int proto_sctp_send(struct socket_info *source, char *buf, unsigned len,
-										union sockaddr_union* to, int id)
+									union sockaddr_union* to, unsigned int id)
 {
 	int n;
 	int tolen;
diff --git a/modules/proto_sctp/sctp_server.h b/modules/proto_sctp/sctp_server.h
index 5f2ba38fef8..57700703f4f 100644
--- a/modules/proto_sctp/sctp_server.h
+++ b/modules/proto_sctp/sctp_server.h
@@ -37,7 +37,7 @@
 int proto_sctp_init_listener(struct socket_info* si);
 
 int proto_sctp_send(struct socket_info *source, char *buf, unsigned len,
-		union sockaddr_union* to, int id);
+		union sockaddr_union* to, unsigned int id);
 
 int proto_sctp_read(struct socket_info *si, int* bytes_read);
 
diff --git a/modules/proto_smpp/proto_smpp.c b/modules/proto_smpp/proto_smpp.c
index a97ae706d53..8d807daf88a 100644
--- a/modules/proto_smpp/proto_smpp.c
+++ b/modules/proto_smpp/proto_smpp.c
@@ -60,7 +60,8 @@ static int child_init(int rank);
 static int smpp_init(struct proto_info *pi);
 static int smpp_init_listener(struct socket_info *si);
 static int smpp_send(struct socket_info* send_sock,
-		char* buf, unsigned int len, union sockaddr_union* to, int id);
+		char* buf, unsigned int len, union sockaddr_union* to,
+		unsigned int id);
 static int smpp_read_req(struct tcp_connection* conn, int* bytes_read);
 static int smpp_write_async_req(struct tcp_connection* con,int fd);
 static int smpp_conn_init(struct tcp_connection* c);
@@ -272,7 +273,8 @@ static int smpp_init_listener(struct socket_info *si)
 }
 
 static int smpp_send(struct socket_info* send_sock,
-		char* buf, unsigned int len, union sockaddr_union* to, int id)
+		char* buf, unsigned int len, union sockaddr_union* to,
+		unsigned int id)
 {
 	LM_INFO("smpp_send called\n");
 
diff --git a/modules/proto_tls/proto_tls.c b/modules/proto_tls/proto_tls.c
index f6cfab25e96..9bbec5e35a6 100644
--- a/modules/proto_tls/proto_tls.c
+++ b/modules/proto_tls/proto_tls.c
@@ -112,7 +112,8 @@ static void mod_destroy(void);
 static int proto_tls_init(struct proto_info *pi);
 static int proto_tls_init_listener(struct socket_info *si);
 static int proto_tls_send(struct socket_info* send_sock,
-		char* buf, unsigned int len, union sockaddr_union* to, int id);
+		char* buf, unsigned int len, union sockaddr_union* to,
+		unsigned int id);
 static void tls_report(int type, unsigned long long conn_id, int conn_flags,
 		void *extra);
 static mi_response_t *tls_trace_mi(const mi_params_t *params,
@@ -442,7 +443,8 @@ static struct tcp_connection* tls_sync_connect(struct socket_info* send_sock,
 
 
 static int proto_tls_send(struct socket_info* send_sock,
-				char* buf, unsigned int len, union sockaddr_union* to, int id)
+		char* buf, unsigned int len, union sockaddr_union* to,
+		unsigned int id)
 {
 	struct tcp_connection *c;
 	struct tls_domain *dom;
diff --git a/modules/proto_ws/proto_ws.c b/modules/proto_ws/proto_ws.c
index d5cdc85ed2c..30fa495fb19 100644
--- a/modules/proto_ws/proto_ws.c
+++ b/modules/proto_ws/proto_ws.c
@@ -91,7 +91,8 @@ static int mod_init(void);
 static int proto_ws_init(struct proto_info *pi);
 static int proto_ws_init_listener(struct socket_info *si);
 static int proto_ws_send(struct socket_info* send_sock,
-		char* buf, unsigned int len, union sockaddr_union* to, int id);
+		char* buf, unsigned int len, union sockaddr_union* to,
+		unsigned int id);
 static int ws_read_req(struct tcp_connection* con, int* bytes_read);
 static int ws_conn_init(struct tcp_connection* c);
 static void ws_conn_clean(struct tcp_connection* c);
@@ -321,8 +322,8 @@ static void ws_report(int type, unsigned long long conn_id, int conn_flags,
 
 /*! \brief Finds a tcpconn & sends on it */
 static int proto_ws_send(struct socket_info* send_sock,
-											char* buf, unsigned int len,
-											union sockaddr_union* to, int id)
+		char* buf, unsigned int len, union sockaddr_union* to,
+		unsigned int id)
 {
 	struct tcp_connection *c;
 	struct timeval get;
diff --git a/modules/proto_wss/proto_wss.c b/modules/proto_wss/proto_wss.c
index 87c2b0d9138..6bbe7b87b10 100644
--- a/modules/proto_wss/proto_wss.c
+++ b/modules/proto_wss/proto_wss.c
@@ -107,7 +107,8 @@ static int mod_init(void);
 static int proto_wss_init(struct proto_info *pi);
 static int proto_wss_init_listener(struct socket_info *si);
 static int proto_wss_send(struct socket_info* send_sock,
-		char* buf, unsigned int len, union sockaddr_union* to, int id);
+		char* buf, unsigned int len, union sockaddr_union* to,
+		unsigned int id);
 static int wss_read_req(struct tcp_connection* con, int* bytes_read);
 static int wss_conn_init(struct tcp_connection* c);
 static void ws_conn_clean(struct tcp_connection* c);
@@ -358,8 +359,8 @@ static void wss_report(int type, unsigned long long conn_id, int conn_flags,
 
 /*! \brief Finds a tcpconn & sends on it */
 static int proto_wss_send(struct socket_info* send_sock,
-											char* buf, unsigned int len,
-											union sockaddr_union* to, int id)
+		char* buf, unsigned int len, union sockaddr_union* to,
+		unsigned int id)
 {
 	struct tcp_connection *c;
 	struct tls_domain *dom;
diff --git a/net/api_proto.h b/net/api_proto.h
index 5312ace9d0b..39f708f2a2d 100644
--- a/net/api_proto.h
+++ b/net/api_proto.h
@@ -32,7 +32,7 @@
 
 typedef int (*proto_init_listener_f)(struct socket_info *si);
 typedef int (*proto_send_f)(struct socket_info *si, char* buf,unsigned int len,
-		union sockaddr_union* to, int id);
+		union sockaddr_union* to, int unsigned id);
 typedef int (*proto_dst_attr_f)(struct receive_info *rcv,
 		int attr, void *value);
 
diff --git a/net/net_tcp.c b/net/net_tcp.c
index 985b7c52b99..6ce2fc32641 100644
--- a/net/net_tcp.c
+++ b/net/net_tcp.c
@@ -87,7 +87,7 @@ struct tcp_worker *tcp_workers=0;
 
 /* unique for each connection, used for
  * quickly finding the corresponding connection for a reply */
-static int* connection_id=0;
+static unsigned int* connection_id=0;
 
 /* array of TCP partitions */
 static struct tcp_partition tcp_parts[TCP_PARTITION_SIZE];
@@ -147,7 +147,7 @@ int is_tcp_main = 0;
 
 /* the ID of the TCP conn used for the last send operation in the
  * current process - attention, this is a really ugly HACK here */
-int last_outgoing_tcp_id = 0;
+unsigned int last_outgoing_tcp_id = 0;
 
 static struct scaling_profile *s_profile = NULL;
 
@@ -506,7 +506,7 @@ int tcp_init_listener(struct socket_info *si)
 /*! \brief finds a connection, if id=0 return NULL
  * \note WARNING: unprotected (locks) use tcpconn_get unless you really
  * know what you are doing */
-static struct tcp_connection* _tcpconn_find(int id)
+static struct tcp_connection* _tcpconn_find(unsigned int id)
 {
 	struct tcp_connection *c;
 	unsigned hash;
@@ -515,7 +515,7 @@ static struct tcp_connection* _tcpconn_find(int id)
 		hash=tcp_id_hash(id);
 		for (c=TCP_PART(id).tcpconn_id_hash[hash]; c; c=c->id_next){
 #ifdef EXTRA_DEBUG
-			LM_DBG("c=%p, c->id=%d, port=%d\n",c, c->id, c->rcv.src_port);
+			LM_DBG("c=%p, c->id=%u, port=%d\n",c, c->id, c->rcv.src_port);
 			print_ip("ip=", &c->rcv.src_ip, "\n");
 #endif
 			if ((id==c->id)&&(c->state!=S_CONN_BAD)) return c;
@@ -526,7 +526,7 @@ static struct tcp_connection* _tcpconn_find(int id)
 
 
 /* returns the correlation ID of a TCP connection */
-int tcp_get_correlation_id( int id, unsigned long long *cid)
+int tcp_get_correlation_id( unsigned int id, unsigned long long *cid)
 {
 	struct tcp_connection* c;
 
@@ -543,15 +543,16 @@ int tcp_get_correlation_id( int id, unsigned long long *cid)
 
 
 /*! \brief _tcpconn_find with locks and acquire fd */
-int tcp_conn_get(int id, struct ip_addr* ip, int port, enum sip_protos proto,
-			void *proto_extra_id, struct tcp_connection** conn, int* conn_fd)
+int tcp_conn_get(unsigned int id, struct ip_addr* ip, int port,
+		enum sip_protos proto, void *proto_extra_id,
+		struct tcp_connection** conn, int* conn_fd)
 {
 	struct tcp_connection* c;
 	struct tcp_connection* tmp;
 	struct tcp_conn_alias* a;
 	unsigned hash;
 	long response[2];
-	int part;
+	unsigned int part;
 	int n;
 	int fd;
 
@@ -565,7 +566,7 @@ int tcp_conn_get(int id, struct ip_addr* ip, int port, enum sip_protos proto,
 
 	/* continue search based on IP address + port + transport */
 #ifdef EXTRA_DEBUG
-	LM_DBG("%d  port %d\n",id, port);
+	LM_DBG("%d  port %u\n",id, port);
 	if (ip) print_ip("tcpconn_find: ip ", ip, "\n");
 #endif
 	if (ip){
@@ -574,7 +575,7 @@ int tcp_conn_get(int id, struct ip_addr* ip, int port, enum sip_protos proto,
 			TCPCONN_LOCK(part);
 			for (a=TCP_PART(part).tcpconn_aliases_hash[hash]; a; a=a->next) {
 #ifdef EXTRA_DEBUG
-				LM_DBG("a=%p, c=%p, c->id=%d, alias port= %d port=%d\n",
+				LM_DBG("a=%p, c=%p, c->id=%u, alias port= %d port=%d\n",
 					a, a->parent, a->parent->id, a->port,
 					a->parent->rcv.src_port);
 				print_ip("ip=",&a->parent->rcv.src_ip,"\n");
@@ -614,8 +615,10 @@ int tcp_conn_get(int id, struct ip_addr* ip, int port, enum sip_protos proto,
 	}
 
 	if (c->proc_id == process_no) {
-		LM_DBG("tcp connection found (%p) already in this process ( %d ) , fd = %d\n", c, c->proc_id, c->fd);
-		/* we already have the connection in this worker's reactor, no need to acquire FD */
+		LM_DBG("tcp connection found (%p) already in this process ( %d ) ,"
+			" fd = %d\n", c, c->proc_id, c->fd);
+		/* we already have the connection in this worker's reactor, */
+		/* no need to acquire FD */
 		*conn = c;
 		*conn_fd = c->fd;
 		return 1;
@@ -644,8 +647,8 @@ int tcp_conn_get(int id, struct ip_addr* ip, int port, enum sip_protos proto,
 	}
 	if (c!=tmp){
 		LM_CRIT("got different connection:"
-			"  %p (id= %d, refcnt=%d state=%d != "
-			"  %p (id= %d, refcnt=%d state=%d (n=%d)\n",
+			"  %p (id= %u, refcnt=%d state=%d != "
+			"  %p (id= %u, refcnt=%d state=%d (n=%d)\n",
 			  c,   c->id,   c->refcnt,   c->state,
 			  tmp, tmp->id, tmp->refcnt, tmp->state, n
 		   );
@@ -681,7 +684,7 @@ int tcp_conn_fcntl(struct receive_info *rcv, int attr, void *value)
 		TCPCONN_LOCK(rcv->proto_reserved1);
 		con =_tcpconn_find(rcv->proto_reserved1);
 		if (!con) {
-			LM_ERR("Strange, tcp conn not found (id=%d)\n",
+			LM_ERR("Strange, tcp conn not found (id=%u)\n",
 				rcv->proto_reserved1);
 		} else {
 			tcp_conn_set_lifetime( con, (int)(long)(value));
@@ -777,7 +780,7 @@ static void tcpconn_rm(struct tcp_connection* c)
 
 /*! \brief add port as an alias for the "id" connection
  * \return 0 on success,-1 on failure */
-int tcpconn_add_alias(int id, int port, int proto)
+int tcpconn_add_alias(unsigned int id, int port, int proto)
 {
 	struct tcp_connection* c;
 	unsigned hash;
@@ -814,21 +817,21 @@ int tcpconn_add_alias(int id, int port, int proto)
 	TCPCONN_UNLOCK(id);
 #ifdef EXTRA_DEBUG
 	if (a) LM_DBG("alias already present\n");
-	else   LM_DBG("alias port %d for hash %d, id %d\n", port, hash, id);
+	else   LM_DBG("alias port %d for hash %d, id %u\n", port, hash, id);
 #endif
 	return 0;
 error_aliases:
 	TCPCONN_UNLOCK(id);
-	LM_ERR("too many aliases for connection %p (%d)\n", c, id);
+	LM_ERR("too many aliases for connection %p (%u)\n", c, id);
 	return -1;
 error_not_found:
 	TCPCONN_UNLOCK(id);
-	LM_ERR("no connection found for id %d\n",id);
+	LM_ERR("no connection found for id %u\n",id);
 	return -1;
 error_sec:
 	LM_WARN("possible port hijack attempt\n");
 	LM_WARN("alias already present and points to another connection "
-			"(%d : %d and %d : %d)\n", a->parent->id,  port, id, port);
+			"(%d : %d and %u : %d)\n", a->parent->id,  port, id, port);
 	TCPCONN_UNLOCK(id);
 	return -1;
 }
@@ -1002,7 +1005,7 @@ int tcp_conn_send(struct tcp_connection *c)
 static inline void tcpconn_destroy(struct tcp_connection* tcpconn)
 {
 	int fd;
-	int id = tcpconn->id;
+	int unsigned id = tcpconn->id;
 
 	TCPCONN_LOCK(id); /*avoid races w/ tcp_send*/
 	tcpconn->refcnt--;
@@ -1054,7 +1057,7 @@ static inline int handle_new_connect(struct socket_info* si)
 	struct tcp_connection* tcpconn;
 	socklen_t su_len = sizeof(su);
 	int new_sock;
-	int id;
+	unsigned int id;
 
 	/* coverity[overrun-buffer-arg: FALSE] - union has 28 bytes, CID #200070 */
 	new_sock=accept(si->socket, &(su.s), &su_len);
@@ -1125,7 +1128,7 @@ inline static int handle_tcpconn_ev(struct tcp_connection* tcpconn, int fd_i,
 {
 	int fd;
 	int err;
-	int id;
+	unsigned int id;
 	unsigned int err_len;
 
 	if (event_type == IO_WATCH_READ) {
@@ -1765,12 +1768,14 @@ int tcp_init(void)
 	}
 	memset( tcp_workers, 0, tcp_workers_max_no*sizeof(struct tcp_worker));
 	/* init globals */
-	connection_id=(int*)shm_malloc(sizeof(int));
+	connection_id=(unsigned int*)shm_malloc(sizeof(unsigned int));
 	if (connection_id==0){
 		LM_CRIT("could not alloc globals in shm memory\n");
 		goto error;
 	}
-	*connection_id=rand();
+	// The  rand()  function returns a pseudo-random integer in the range 0 to
+	// RAND_MAX inclusive (i.e., the mathematical range [0, RAND_MAX]).
+	*connection_id=(unsigned int)rand();
 	memset( &tcp_parts, 0, TCP_PARTITION_SIZE*sizeof(struct tcp_partition));
 	/* init partitions */
 	for( i=0 ; i<TCP_PARTITION_SIZE ; i++ ) {
diff --git a/net/net_tcp.h b/net/net_tcp.h
index 7aea68687cb..487a74e8026 100644
--- a/net/net_tcp.h
+++ b/net/net_tcp.h
@@ -90,8 +90,9 @@ int tcp_connect_blocking_timeout(int s, const struct sockaddr *servaddr,
 /********************** TCP conn management functions ************************/
 
 /* returns the connection identified by either the id or the destination to */
-int tcp_conn_get(int id, struct ip_addr* ip, int port, enum sip_protos proto,
-		void *proto_extra_id, struct tcp_connection** conn, int* conn_fd);
+int tcp_conn_get(int unsigned id, struct ip_addr* ip, int port,
+		enum sip_protos proto, void *proto_extra_id,
+		struct tcp_connection** conn, int* conn_fd);
 
 /* creates a new tcp conn around a newly connected socket
  * and sends it to the master */
@@ -115,8 +116,8 @@ void tcp_conn_destroy(struct tcp_connection* tcpconn);
 int tcp_conn_fcntl(struct receive_info *rcv, int attr, void *value);
 
 /* returns the correlation ID of a TCP connection */
-int tcp_get_correlation_id( int id, unsigned long long *cid);
+int tcp_get_correlation_id( unsigned int id, unsigned long long *cid);
 
-extern int last_outgoing_tcp_id;
+extern unsigned int last_outgoing_tcp_id;
 
 #endif /* _NET_TCP_H_ */
diff --git a/net/proto_tcp/proto_tcp.c b/net/proto_tcp/proto_tcp.c
index 5ccd0dc5364..843b1151a19 100644
--- a/net/proto_tcp/proto_tcp.c
+++ b/net/proto_tcp/proto_tcp.c
@@ -51,7 +51,8 @@ static int mod_init(void);
 static int proto_tcp_init(struct proto_info *pi);
 static int proto_tcp_init_listener(struct socket_info *si);
 static int proto_tcp_send(struct socket_info* send_sock,
-		char* buf, unsigned int len, union sockaddr_union* to, int id);
+		char* buf, unsigned int len, union sockaddr_union* to,
+		unsigned int id);
 inline static int _tcp_write_on_socket(struct tcp_connection *c, int fd,
 		char *buf, int len);
 
@@ -760,8 +761,8 @@ inline static int _tcp_write_on_socket(struct tcp_connection *c, int fd,
 
 /*! \brief Finds a tcpconn & sends on it */
 static int proto_tcp_send(struct socket_info* send_sock,
-											char* buf, unsigned int len,
-											union sockaddr_union* to, int id)
+									char* buf, unsigned int len,
+									union sockaddr_union* to, unsigned int id)
 {
 	struct tcp_connection *c;
 	struct ip_addr ip;
diff --git a/net/proto_udp/proto_udp.c b/net/proto_udp/proto_udp.c
index 2e6bfd855ca..8f2c4cabdd7 100644
--- a/net/proto_udp/proto_udp.c
+++ b/net/proto_udp/proto_udp.c
@@ -44,7 +44,8 @@ static int mod_init(void);
 static int proto_udp_init(struct proto_info *pi);
 static int proto_udp_init_listener(struct socket_info *si);
 static int proto_udp_send(struct socket_info* send_sock,
-		char* buf, unsigned int len, union sockaddr_union* to, int id);
+		char* buf, unsigned int len, union sockaddr_union* to,
+		unsigned int id);
 
 static int udp_read_req(struct socket_info *src, int* bytes_read);
 
@@ -198,7 +199,8 @@ static int udp_read_req(struct socket_info *si, int* bytes_read)
  * \return -1 on error, the return value from sento on success
  */
 static int proto_udp_send(struct socket_info* source,
-		char* buf, unsigned int len, union sockaddr_union* to, int id)
+		char* buf, unsigned int len, union sockaddr_union* to,
+		unsigned int id)
 {
 	int n, tolen;
 
diff --git a/net/tcp_conn_defs.h b/net/tcp_conn_defs.h
index 52cd232a543..132a82d3b5b 100644
--- a/net/tcp_conn_defs.h
+++ b/net/tcp_conn_defs.h
@@ -105,7 +105,7 @@ struct tcp_connection{
 	int fd;					/*!< used only by "children", don't modify it! private data! */
 	int proc_id;				/*!< used only by "children", contains the pt table ID of the TCP worker currently holding the connection, or -1 if in TCP main */
 	gen_lock_t write_lock;
-	int id;					/*!< id (unique!) used to retrieve a specific connection when reply-ing*/
+	unsigned int id;				/*!< id (unique!) used to retrieve a specific connection when reply-ing*/
 	unsigned long long cid;					/*!< connection id (unique!) used to uniquely identify connections across space and time */
 	struct receive_info rcv;		/*!< src & dst ip, ports, proto a.s.o*/
 	volatile int refcnt;
@@ -139,7 +139,7 @@ struct tcp_connection{
 
 /*! \brief add port as an alias for the "id" connection
  * \return 0 on success,-1 on failure */
-int tcpconn_add_alias(int id, int port, int proto);
+int tcpconn_add_alias(unsigned int id, int port, int proto);
 
 
 #define tcp_conn_set_lifetime( _c, _lt) \
